/*
 * Created on 05-Nov-2004
 *
 */
package org.ucam.srcf.assassins;

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;
import org.ucam.srcf.assassins.exceptions.StateBuilderException;

/**
 * @author Mike Cripps
 *
 */
public class LightweightStateBuilder {

	private List assassins;
	private long time;
	
	/**
	 * 
	 */
	public LightweightStateBuilder(long time) {
		this.assassins=new LinkedList();
		this.time=time;
	}

   /**
    * @param a
    */
   public void registerInterest(Assassin a) {
      this.assassins.add(a);
   }
   
   public List getInvolved() {
      return assassins;
   }

   /**
    * @return
    * @throws StateBuilderException
    */
   public Map generateState() throws StateBuilderException {
      // Generate state only for assassins in the List 'assassins'
      // Should be much faster! ;)
      // Mike
      Map states = new HashMap();
      Iterator i = assassins.iterator();
      while (i.hasNext())
      {
         Assassin a = (Assassin) i.next();
         AssassinState s = new AssassinState(a);
         states.put(a, s);
         try {
  /*          Pseudonym.preCache();
            StateChange.preCache(); */
            List l = StateChange.getActiveByAssassin(a, time);
            // But it should do for now
            Iterator li = l.iterator();
            while (li.hasNext()) {
               StateChange sc = (StateChange) li.next();
               Assassin a2 = sc.getAssassin();
               String pname = sc.getPluginName();
               String field = sc.getFieldName();
               Object value = sc.getValue();
               if (sc instanceof PseudonymGain) {
                  ((AssassinState)states.get(a2)).addPseudonym((Pseudonym) value);
               } else if (sc instanceof PseudonymLoss) {
                  ((AssassinState)states.get(a2)).removePseudonym((Pseudonym) value);
               } else {
                  if (sc instanceof Death) {
                     field = "alive";
                     value = "false";
                  } else if (sc instanceof Resurrection) {
                     field = "alive";
                     value = "true";
                  }
                  ((AssassinState)states.get(a2)).setProperty(pname,field,value);
               }
            }
         } catch (AssassinSQLException asqle) {
            throw new StateBuilderException(asqle);
         }
         
      }
      
      return states;
   }

}
