package org.ucam.srcf.assassins.xml;

// JAXP
//import javax.xml.parsers.*;
//import org.xml.sax.*;
//import org.xml.sax.helpers.*;
import java.util.Map;

import org.ucam.srcf.assassins.AssassinState;
import org.ucam.srcf.assassins.AssassinStateViewer;
import org.ucam.srcf.assassins.Debug;
import org.ucam.srcf.assassins.Plugin;
import org.ucam.srcf.assassins.exceptions.AssassinSQLException;

//import org.ucam.srcf.assassins.Debug;
//import org.ucam.srcf.assassins.exceptions.XMLParseException;

public class ColourFilterFilter extends ColourFilter {

   private String plugin;
   private String property;
   private String condition;
   
   public void setFilter(String pl, String pr, String c)
   {
      plugin = pl;
      property = pr;
      condition = c;
   }
   
   public boolean matchAssassinState(Map plugins, AssassinState as)
   {
      Plugin plug = (Plugin) plugins.get(plugin);
      if (null == plug) return false;
      try
      {
         if (Debug.debug)
         {
            boolean result = plug.assassinHasProperty(new AssassinStateViewer(as), property, condition);
            Debug.print(ColourFilterFilter.class, "assassinHasProperty: " + plugin + "," + property + "," + condition + " == " + result);
            return result;
         }
         return plug.assassinHasProperty(new AssassinStateViewer(as), property, condition);
      }
      catch (AssassinSQLException ASex)
      {
         // silent failure. sorry.
         return false;
      }
   }

   public String debugName()
   {
      return "[" + plugin + ":" + property + "=" + condition + "]";
   }
}
